# Doodle, drawing and painting for children in an Android App.

Discover a fun and educational experience for your children with this app! This innovative application offers a variety of pre-made drawings that children can color to their heart's content. From cute animals to exciting adventures - there's something suitable for every taste!

Features:

* Wide selection of pictures: Our app provides an extensive collection of images for children of all ages and interests. From animal lovers to space adventurers, there are countless opportunities to unleash creativity.

* Easy operation: The user interface is child-friendly and allows little ones to navigate effortlessly between pictures and select their favorite drawings.

* Interactive color selection: With a wide range of colors, children can bring their imagination to life and add a personal touch to their pictures.

* Learning and developmental aspect: Coloring not only promotes artistic creativity but also fine motor skills and children's ability to concentrate.

* Offline access: The app works without an internet connection, so your children can have fun anytime, anywhere.

Let your children dive into a world of colors and fantasy and try the app now!

International Age Ratings:

* ACB: G (general)
* ClassInd: L
* ESRB: E (everyone)
* PEGI: 3
* USK: 0
* IARC: 3

[<img src="https://fdroid.gitlab.io/artwork/badge/get-it-on.png"
     alt="Get it on F-Droid"
     height="80">](https://f-droid.org/packages/ardash.doodledudette/)

# Screenshots
<p float="left">
  <img src="metadata/en-GB/images/phoneScreenshots/00flower.png" width="49%" />
  <img src="metadata/en-GB/images/phoneScreenshots/02lion.png" width="49%" /> 
</p>

<p float="left">
  <img src="metadata/en-GB/images/phoneScreenshots/03pig.png" width="49%" />
  <img src="metadata/en-GB/images/phoneScreenshots/01rocket.png" width="49%" /> 
</p>

<p float="left">
  <img src="metadata/en-GB/images/phoneScreenshots/07monkey.png" width="49%" />
  <img src="metadata/en-GB/images/phoneScreenshots/05bee.png" width="49%" /> 
</p>

# Name of the Game
The name of the game is the English Doodle Dudette. "Doodle Dudette" is the female version of "Doodle Dude" which means "Doodle Guy" oder "Doodle Boy". The female version has a funny childish sound to it (this game is for children). 

"Doodle" means drawing or painting or whatever children usually do with a drawing device.

When you install the app on a phone with another language, the name is phonetically translated. So a child, who is old enough to read it, will still read words that sound like "Doodle Dudette", so he/she/they will say the name of the app correctly. However, they can read it in their own language and are not required to learn English.

If you are interested, how the name of this app is in another language you can see a listing here: https://gitlab.com/ar-/doodle-dudette/-/blob/master/doc/translations?ref_type=heads or simply browse the Android ressourcess here: https://gitlab.com/ar-/doodle-dudette/-/tree/master/android/res?ref_type=heads .

# License
    Doodle, drawing and painting for children in an Android App
    Copyright (C) 2024  Andreas Redmer

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
# Icon
Image by <a href=" https://www.vectorportal.com" >Vectorportal.com</a>,  <a class="external text" href="https://creativecommons.org/licenses/by/4.0/" >CC BY</a>

# Size of the app
The app is heavily optimized for file size in order to be scalable up to thousands of images.

6592334 android/build/outputs/apk/debug/android-debug.apk
3417728 android/build/outputs/apk/debugmin/android-debugmin.apk
3388135 android/build/outputs/apk/release/android-release-unsigned.apk
