package ardash.doodledudette;

import android.os.Bundle;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.backends.android.AndroidApplication;
import com.badlogic.gdx.backends.android.AndroidApplicationConfiguration;
import ardash.doodledudette.DDGame;

import android.util.Log;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import com.caverock.androidsvg.SVG;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import android.content.Intent;
import android.net.Uri;
import android.util.Base64;
import com.badlogic.gdx.graphics.Pixmap;
import com.badlogic.gdx.graphics.Texture;

import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Bundle;
import com.badlogic.gdx.backends.android.AndroidApplication;
import com.badlogic.gdx.backends.android.AndroidApplicationConfiguration;
import com.badlogic.gdx.graphics.Pixmap;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.PixmapIO;
import com.badlogic.gdx.utils.BufferUtils;
import java.io.File;
import java.io.IOException;
import com.badlogic.gdx.files.FileHandle;
import androidx.core.content.FileProvider;

import java.text.DateFormat;
import java.util.Date;
import java.util.Locale;

import android.widget.Toast;

public class AndroidLauncher extends AndroidApplication implements ActionResolver {
	
	private static final String TAG = "doodledudette";
	
	@Override
	protected void onCreate (Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		AndroidApplicationConfiguration config = new AndroidApplicationConfiguration();
		initialize(new DDGame(this), config);
	}

	@Override
	public byte[] convertSvgBytesToPngBytes(byte[] svgData, int width, int height) {
	    try {
	    	Log.d(TAG, "Debug message: Parsing SVG...");
	    	SVG svg = SVG.getFromInputStream(new ByteArrayInputStream(svgData));
	    	Log.d(TAG, "Debug message: Creatign Canvas...");
	        Bitmap bitmap = Bitmap.createBitmap(width, height, Bitmap.Config.ARGB_8888);
	        Canvas canvas = new Canvas(bitmap);
	    	Log.d(TAG, "Debug message: Rendering SVG...");
	        svg.renderToCanvas(canvas);
	
	        ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
	    	Log.d(TAG, "Debug message: Compressing to PNG...");
	        bitmap.compress(Bitmap.CompressFormat.PNG, 100, outputStream);
	    	Log.d(TAG, "Debug message: Returning from convertSvgBytesToPngBytes.");
	        return outputStream.toByteArray();
	    } catch (Exception e) {
	        e.printStackTrace();
	        return null;
	    }
	}

	// Method to share a Libgdx Texture as a PNG image
	@Override
	public void shareImage(Texture texture) {
        // Convert Texture to Pixmap
        Pixmap pixmap = texture.getTextureData().consumePixmap();

        // Save Pixmap to a temporary file
        File tempFile = savePixmapToTempFile(pixmap);

        // Share the temporary file URI
        if (tempFile != null) {
            shareFile(tempFile);
        }
    }

    // Helper method to save Pixmap to a temporary file
    private File savePixmapToTempFile(Pixmap pixmap) {
        File tempFile = null;
        try {
        	String appName = getResources().getString(R.string.app_name); // Get the localized app name
        	appName = appName.replaceAll("\\s+", "_").toLowerCase()+"_"; // Replace whitespaces with underscores
            tempFile = File.createTempFile(appName, ".png", getCacheDir());
            PixmapIO.writePNG(new FileHandle(tempFile), pixmap);
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
//            pixmap.dispose(); // dont Dispose Pixmap, otherwise we cant continue drawing after sharing
        }
        return tempFile;
    }

    // Helper method to share the file URI
    private void shareFile(File file) {
    	String appName = getResources().getString(R.string.app_name); // Get the localized app name
        DateFormat dateFormat = DateFormat.getDateTimeInstance(DateFormat.DEFAULT, DateFormat.DEFAULT, Locale.getDefault());
        String dateTimeString = dateFormat.format(new Date());
        
        final String extraMessage = appName + " " + dateTimeString;
        
        String packageName = getApplicationContext().getPackageName();
        Uri fileUri = FileProvider.getUriForFile(this, packageName+".fileprovider", file);
        Intent shareIntent = new Intent(Intent.ACTION_SEND);
        shareIntent.setType("image/png");
        shareIntent.putExtra(Intent.EXTRA_STREAM, fileUri);
        shareIntent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION); // Grant temporary read permission to the receiving app
        shareIntent.putExtra(Intent.EXTRA_TEXT, extraMessage);
        startActivity(Intent.createChooser(shareIntent, "Share image via"));
        
    }

	@Override
	public void showToast(String message) {
		runOnUiThread(new Runnable() {
            @Override
            public void run() {
        		Toast.makeText(getApplicationContext(), message, Toast.LENGTH_SHORT).show();
            }
        });
	}

}
