package ardash.doodledudette;

import com.badlogic.gdx.Application;
import com.badlogic.gdx.Game;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Screen;
import com.badlogic.gdx.utils.ScreenUtils;

import ardash.doodledudette.screens.LoadingScreen;
import ardash.doodledudette.screens.PictureSelectionScreen;

public class DDGame extends Game {
//	SpriteBatch batch;
//	Texture img;
	private static final String TAG = "doodledudette.DDGame";
	private final ActionResolver actionResolver;

	public DDGame(ActionResolver actionResolver) {
		super();
		this.actionResolver = actionResolver;
	}

	public ActionResolver getActionResolver() {
		return actionResolver;
	}

	@Override
	public void create() {
		Gdx.app.setLogLevel(Application.LOG_DEBUG);
		// initialize the GameManager
		GameManager.getInstance(this);

		DDGame caller = this;
		// start the Game on the first Screen
		final LoadingScreen loadingScreen = new LoadingScreen() {
			@Override
			public void doAfterShow() {
//				 setScreen(new GameScreen());
				setScreen(new PictureSelectionScreen(caller));
			}
		};
		setScreen(loadingScreen);
	}

	@Override
	public void setScreen(Screen screen) {
		// add logging to set screen (includes the show() method
		Gdx.app.log(TAG, "start setScreen");
		super.setScreen(screen);
		Gdx.app.log(TAG, "end   setScreen");
	}

	@Override
	public void render() {
		ScreenUtils.clear(1, 0, 0, 1);
		super.render();
	}

	@Override
	public void dispose() {
		// dispose current screen
		getScreen().dispose();
	}
}
