package ardash.doodledudette;

public class GameManager {

	private DDGame game;
	private static GameManager INSTANCE;

	private GameManager(DDGame game) {
		super();
		this.game = game;
	}

	public static GameManager getInstance(DDGame game) {
		if (INSTANCE == null) {
			INSTANCE = new GameManager(game);
		}
		return INSTANCE;
	}

	public static GameManager getInstance() {
		if (INSTANCE == null) {
			throw new RuntimeException("GameManager Singleton must be called with a Game instance the first time");
		}
		return INSTANCE;
	}

	private DDGame getGame() {
		return game;
	}

	public ActionResolver getActionResolver() {
		return getGame().getActionResolver();
	}

}
