package ardash.doodledudette;

import com.badlogic.gdx.graphics.Color;

public class HSLColor {
	private float H, S, L;
	private Color rgb;


	public HSLColor(HSLColor copy) {
		super();
		this.setH(copy.getH());
		this.setS(copy.getS());
		this.setL(copy.getL());
	}

	public HSLColor(float h, float s, float l) {
		super();
		setH(h);
		setS(s);
		setL(l);
	}

	public Color getRGBColor() {
		rgb = HSLColorConverter.fromHSL(H, S, L);
		return rgb;
	}

	public float getH() {
		return H;
	}

	public void setH(float h) {
		if (h > 360f) {
			throw new RuntimeException("H must not be higher than 360, but was " + h);
		}
		if (h < 0f) {
			throw new RuntimeException("H must not be lower than 0, but was " + h);
		}
		H = h;
	}

	public float getS() {
		return S;
	}

	public void setS(float s) {
		if (s > 1f) {
			throw new RuntimeException("S must not be higher than 1, but was " + s);
		}
		if (s < 0f) {
			throw new RuntimeException("S must not be lower than 0, but was " + s);
		}
		S = s;
	}

	public float getL() {
		return L;
	}

	public void setL(float l) {
		if (l > 1f) {
			throw new RuntimeException("L must not be higher than 1, but was " + l);
		}
		if (l < 0f) {
			throw new RuntimeException("L must not be lower than 0, but was " + l);
		}
		L = l;
	}

}
