package ardash.doodledudette;

import com.badlogic.gdx.graphics.Color;

public class HSLColorConverter {
	public static Color fromHSL(float hue, float saturation, float lightness) {
		float c = (1f - Math.abs(2 * lightness - 1f)) * saturation;
		float h = hue / 60f;
		float x = c * (1f - Math.abs(h % 2f - 1f));
		float r1, g1, b1;

		if (0 <= h && h < 1) {
			r1 = c;
			g1 = x;
			b1 = 0;
		} else if (1 <= h && h < 2) {
			r1 = x;
			g1 = c;
			b1 = 0;
		} else if (2 <= h && h < 3) {
			r1 = 0;
			g1 = c;
			b1 = x;
		} else if (3 <= h && h < 4) {
			r1 = 0;
			g1 = x;
			b1 = c;
		} else if (4 <= h && h < 5) {
			r1 = x;
			g1 = 0;
			b1 = c;
		} else {
			r1 = c;
			g1 = 0;
			b1 = x;
		}

		float m = lightness - 0.5f * c;
		float r = r1 + m;
		float g = g1 + m;
		float b = b1 + m;

		return new Color(r, g, b, 1f);
	}
}
